#import <objc/Object.h>
#import <soundkit/Sound.h>
#import <soundkit/NXPlayStream.h>

@interface SoundEffect:Object
{
    Sound *sound;			// The sound data for this sound
    struct {
        unsigned int refCount:24;	// Number of play requests pending
	unsigned int freeWhenDone:1;	// Free when all are done
	unsigned int :7;
    } flags;
}

- initFromSection:(const char *)sound;
- play;
- play:(float)volume pan:(float)rads;
- free;

+ (void)setSoundEnabled:(BOOL)flag;
+ (BOOL)soundEnabled;

+ (void)setMaxSoundStreams:(unsigned int)max;
+ (unsigned int)maxSoundStreams;

// Internal methods.

+ (NXPlayStream *)soundStream;
+ (void)releaseSoundStream:(NXPlayStream *)soundStream;

@end

